
sub onevarstr {
	my $store = $_[0];
	my $setting = $_[1];
	my $var = $_[2];

	return (($store eq "") ? "" : "0x" . ( ("00000000" . $store) =~ s|^0*([0-9A-F]{8})|$1|r ) . ":") . "0x" . ( ("00000000" . $var) =~ s|^0*([0-9A-F]{8})|$1|r ) . " " . $thepath . "\\" . $setting;
}


sub onevar {
	my $store = $_[0];
	my $setting = $_[1];
	my $var = $_[2];
	print (onevarstr($store, $setting, $var));
}


$thepath="";
while (<>) {
	   if ( /^0x[0-9A-F]+\s+Form Set: (.*) {[0-9A-F ]+}/ ) { $thepath = $thepath . "\\" . $1 }
	elsif ( /^0x[0-9A-F]+\s+Form: (.*), (?:Form ID|FormId): 0x([0-9A-F]+) {[0-9A-F ]+}/ ) { $thepath = $thepath . "\\" . $1 }
	elsif ( /^0x[0-9A-F]+\s+End Form {[0-9A-F ]+}/ ) { $thepath =~ s|^(.*)\\[^\\]*$|$1| }
	elsif ( /^0x[0-9A-F]+\s+End Form Set {[0-9A-F ]+}/ ) { $thepath =~ s|^(.*)\\[^\\]*$|$1| }

	# MacPro3,1 old style IFR

	elsif ( /^0x[0-9A-F]+\s+Setting: (.*), Variable: 0x([0-9A-F]+\[[^]]+\]) {[0-9A-F ]+}/ ) {
		onevar("", $1, $2);
		$options = "";
		$optiontype = "Setting";
	}
	elsif ( /^0x[0-9A-F]+\s+(\w+): (.*), Variable: 0x([0-9A-F]+\[[^]]+\]) {[0-9A-F ]+}/ ) {
		onevar("", $2, $3);
		print " ($1)\n"; # Checkbox, Numeric, Password, String
	}
	elsif ( /^0x[0-9A-F]+\s+(Date|Time): (.*), (.*), (.*), Variables: 0x([0-9A-F]+\[[^]]+\]), 0x([0-9A-F]+\[[^]]+\]), 0x([0-9A-F]+\[[^]]+\]) {[0-9A-F ]+}/ ) {
		onevar("", $2, $5);
		print " ($1)\n";
		onevar("", $3, $6);
		print " ($1)\n";
		onevar("", $4, $7);
		print " ($1)\n";
	}
	elsif ( /^0x[0-9A-F]+\s+Option: (.*), Value: (0x[0-9A-F]+) {[0-9A-F ]+}/ ) { 
		$option = $1;
		$val = $2 =~ s|0x([0-9])$|$1|r;
		if ($options ne "") { $options .= "; " }
		$options .= ($val . "=\"" . $option . "\"")
	}
	elsif ( /^0x[0-9A-F]+\s+End of Options {[0-9A-F ]+}/ ) {
		print " (" . $optiontype . ": ", $options . ")\n"
	}

	# New style IFR

	elsif ( /^0x[0-9A-F]+\s+(Checkbox): (.*), VarStoreInfo \(VarOffset\/VarName\): (?!0xFFFF)0x([0-9A-F]+), VarStore: 0x([0-9A-F]+), QuestionId: 0x[0-9A-F]+ {[0-9A-F ]+}/ ) {
		$vartype = $1;
		$varname = $2;
		$varoffset = $3;
		$varstore = $4;
		onevar($varstore, $varname, $varoffset . "[1]");
		print " (" . $vartype . ")\n";
	}

	elsif ( /^0x[0-9A-F]+\s+(Numeric): (.*), VarStoreInfo \(VarOffset\/VarName\): (?!0xFFFF)0x([0-9A-F]+), VarStore: 0x([0-9A-F]+), QuestionId: 0x[0-9A-F]+, Size: (\d+), Min: (0x[0-9A-F]+), Max (0x[0-9A-F]+), Step: (0x[0-9A-F]+) {[0-9A-F ]+}/ ) {
		$vartype = $1;
		$varname = $2;
		$varoffset = $3;
		$varstore = $4;
		$varsize = $5;
		$varmin = $6;
		$varmax = $7;
		$varstep = $8 =~ s|0x([0-9])$|$1|r;
		onevar($varstore, $varname, $varoffset . "[" . $varsize . "]");
		print " (" . $vartype . " [" . $varmin =~ s|0x([0-9])$|$1|r . "-" . $varmax =~ s|0x([0-9])$|$1|r . "]" . (($varstep ne "0" && $varstep ne "1") ? " by " . $varstep : "") . ")\n";
	}

	elsif ( /^0x[0-9A-F]+\s+(One Of): (.*), VarStoreInfo \(VarOffset\/VarName\): (?!0xFFFF)0x([0-9A-F]+), VarStore: 0x([0-9A-F]+), QuestionId: 0x[0-9A-F]+, Size: (\d+), Min: (0x[0-9A-F]+), Max (0x[0-9A-F]+), Step: (0x[0-9A-F]+) {[0-9A-F ]+}/ ) {
		$vartype = $1;
		$varname = $2;
		$varoffset = $3;
		$varstore = $4;
		$varsize = $5;
		$varmin = $6;
		$varmax = $7;
		$varstep = $8 =~ s|0x([0-9])$|$1|r;
		onevar($varstore, $varname, $varoffset . "[" . $varsize . "]");
		$options = "";
		$sets = "";
		$optiontype = $vartype . " [" . $varmin =~ s|0x([0-9])$|$1|r . "-" . $varmax =~ s|0x([0-9])$|$1|r . "]" . (($varstep ne "0" && $varstep ne "1") ? " by " . $varstep : "");
	}

	elsif ( /^0x[0-9A-F]+\s+(One Of Option): (.*), Value (\(\d+ bit\)): (0x[0-9A-F]+)( \(.*\)|) {[0-9A-F ]+}/ ) {
		$optiontype = $1;
		$optionname = $2;
		$optioninfo = $3;
		$optionval = $4;
		if ($options ne "") { $options .= "; " }
		$options .= ($optionval =~ s|0x([0-9])$|$1|r . $optioninfo . "=\"" . $optionname . "\"")
	}

	elsif ( /^0x[0-9A-F]+\s+End One Of {[0-9A-F ]+}/ ) {
		print " (" . $optiontype . ": ", $options . ")\n";
		$optiontype = "";
		print $sets;
	}

	elsif ( /^0x[0-9A-F]+\s+(\w+): (.*), VarStoreInfo \(VarOffset\/VarName\): (?!0xFFFF)0x([0-9A-F]+), VarStore: 0x([0-9A-F]+), QuestionId: 0x[0-9A-F]+, MinSize: (0x[0-9A-F]+), MaxSize:? (0x[0-9A-F]+) {[0-9A-F ]+}/ ) {
		$vartype = $1;
		$varname = $2;
		$varoffset = $3;
		$varstore = $4;
		$varminsize = $5;
		$varmaxsize = $6;
		onevar($varstore, $varname, $varoffset . "[" . $varminsize =~ s|0x([0-9])$|$1|r . "-" . $varmaxsize =~ s|0x([0-9])$|$1|r . "]");
		print " (" . $vartype . ")\n"; # Password, String
	}

	elsif ( /^0x[0-9A-F]+\s+(\w+): VarStoreId: 0x([0-9A-F]+), VarStoreInfo \(VarOffset\/VarName\): (?!0xFFFF)0x([0-9A-F]+), VarStoreType: 0x([0-9A-F]+) {[0-9A-F ]+}/ ) {
		$vartype = $1;
		$varstore = $2;
		$varname = "";
		$varoffset = $3;
		$varstoretype = $4;
		
		$thestring = onevarstr($varstore, $varname, $varoffset) . " (" . $vartype . " VarStoreType:" . $varstoretype . ")\n";
		
		if ($optiontype eq "") {
			print $thestring;
		}
		else
		{
			$sets = $sets . $thestring;
		}
	}
}
