UEFIstuff=/Volumes/Work/Programming/EFIProjects/UEFIstuff

UEFIExtractdir="$UEFIstuff/UEFITool/joevt-UEFITool-new_engine/UEFIExtract/"
UEFIExtractbin="$UEFIExtractdir/UEFIExtract"
UEFIToolapp="$UEFIstuff/UEFITool/joevt-UEFITool-new_engine/build-uefitool-Qt_6_1_3_for_macOS-Debug/UEFITool.app"
UEFIToolbin="$UEFIToolapp/Contents/macOS/UEFITool"
UEFITooldir="$UEFIToolapp"
ifrextract=$UEFIstuff/Universal-IFR-Extractor/joevt-Universal-IFR-Extractor/ifrextract
alias ifrextract="$ifrextract"

UEFIExtract () {
	local thefilepath="$1"
	local thefilename="$(basename $thefilepath)"
	pushd "$(dirname "$thefilepath")"
	local thefiledir="$(pwd)"
	popd
	pushd "$UEFIExtractdir"
	"$UEFIExtractbin" "${thefiledir}/${thefilename}" > "${thefiledir}/${thefilename}".UEFIExtract.txt
	popd
}

UEFIDump () {
	local thefilepath="$1"
	local thefilename="$(basename $thefilepath)"
	pushd "$(dirname "$thefilepath")"
	local thefiledir="$(pwd)"
	popd
	pushd "$UEFIExtractdir"
	"$UEFIExtractbin" "${thefiledir}/${thefilename}" unpack > "${thefiledir}/${thefilename}".UEFIDump.txt
	popd
}

UEFITool () {
	local thefilepath="$1"
	local thefilename="$(basename $thefilepath)"
	pushd "$(dirname "$thefilepath")"
	local thefiledir="$(pwd)"
	popd
	# don't use "open" since that does not give access to stdout
	#open -a "$UEFIToolbin" $1 > $1.stdout.txt
	
	"$UEFIToolbin" "${thefiledir}/${thefilename}" > "${thefiledir}/${thefilename}".UEFITool.txt 2> /dev/null &

	# The menus are not automatically enabled unless "open -a" is used. Workaround is to go to Finder and back.
	sleep 2
	osascript -e 'tell application "Finder" to activate'
	osascript -e 'tell application "'"$UEFIToolbin"'" to activate' 2> /dev/null
}

ifrextractgetvars () {
	local thefile="$1"
	perl "$UEFIstuff/ifrextractgetvars.pl" < "$thefile" | sort
}


# Run ifrextract on all PE32 images to see if they contain IFR
ifrextractall () {
	local filenum=0
	IFS=$'\n'
	for thefile in $(find . -iname body.bin -ipath '* PE32 image section/*' -path '*.dump/*'); do
		ifrextract "$thefile" /tmp/ifr.txt > /tmp/ifrresult.txt
		grep -q "error: Unknown protocol" /tmp/ifrresult.txt && continue
	
		(( filenum++ ))

		echo setup_ifr_$filenum.txt $thefile
	
		cp /tmp/ifr.txt setup_ifr_$filenum.txt
		cp /tmp/ifrresult.txt setup_ifr_${filenum}_result.txt
		
		ifrextractgetvars "setup_ifr_$filenum.txt"
	done
}
